#pragma once

#include "EpgDataCap.h"

class CEpgDataCapDllUtil
{
public:
	CEpgDataCapDllUtil(void);
	~CEpgDataCapDllUtil(void);

	DWORD Initialize(BOOL bAsyncMode=TRUE);
	DWORD UnInitialize();
	DWORD AddTSPacket(
		BYTE* pbData,
		DWORD dwSize
		);
	DWORD GetPFData(
		WORD wSID,
		EPG_DATA_INFO* pstEpgData,
		BOOL bNextData
		);
	DWORD ReleasePFData(
		EPG_DATA_INFO* pstEpgData
		);

	void ClearData();
	void SetPFOnly( BOOL bPFOnly );
	void SetBasicMode( BOOL bBasicOnly );
	DWORD GetTSID();
	__int64 GetNowTime();

	DWORD GetEpgCapStatus();
	DWORD GetDefSID();

	const WCHAR* GetTsName();
	
	DWORD GetServiceList(
		SERVICE_INFO** pstList,
		DWORD* dwListSize
		);
	void ReleaseServiceList();
	void ClearBuff();
	
protected:
	HMODULE m_hModule;

	InitializeEP pfnInitializeEP;
	UnInitializeEP pfnUnInitializeEP;
	AddTSPacketEP pfnAddTSPacketEP;
	GetPFDataEP pfnGetPFDataEP;
	ReleasePFDataEP pfnReleasePFDataEP;
	ClearDataEP pfnClearDataEP;
	SetPFOnlyEP pfnSetPFOnlyEP;
	SetBasicModeEP pfnSetBasicModeEP;
	GetTSIDEP pfnGetTSIDEP;
	GetNowTimeEP pfnGetNowTimeEP;
	GetEpgCapStatusEP pfnGetEpgCapStatusEP;
	GetDefSIDEP pfnGetDefSIDEP;
	GetTsNameEP pfnGetTsNameEP;
	GetServiceListEP pfnGetServiceList;
	ReleaseServiceListEP pfnReleaseServiceList;
	ClearBuffEP pfnClearBuff;
protected:
	BOOL LoadDll(void);
	BOOL UnLoadDll(void);
};
